Modules/Transisi/Routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::prefix('transisi')->group(function() {
    Route::get('/', 'TransisiController@index');
});

Route::middleware(['auth'])->group(function () {
    // Route::get('employees/company/{id}/pdf', 'EmployeeController@exportPdf')->name('employees.pdf');
    Route::get('employees/company/{id}', 'EmployeeController@filter')->name('employees.filter');
    Route::post('employees/import', 'EmployeeController@importExcel')->name('employees.import_excel');
    Route::resource('employees', EmployeeController::class);
    
    Route::get('companies/export/{id}', 'CompanyController@exportPdf')->name('companies.export.pdf');
    Route::resource('companies', 'CompanyController');
    
    Route::post('companies/get-companies', 'CompanyController@getCompanies')->name('companies.getCompanies');
});

Modules/Transisi/Entities/Company.php
<?php

namespace Modules\Transisi\Entities;

use Illuminate\Database\Eloquent\Model;

class Company extends Model
{
    protected $fillable = ['name', 'email', 'logo', 'website'];
    
    public function employees()
    {
        return $this->hasMany(Employee::class, 'company_id');
    }
}

Modules/Transisi/Http/Controllers/Api/CompanyController.php
<?php

namespace Modules\Transisi\Http\Controllers\Api;

use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\Storage;
use Illuminate\Contracts\Support\Renderable;
use Modules\Transisi\Repositories\CompanyRepository;
use Modules\Transisi\Http\Requests\CompanyStoreRequest;
use Modules\Transisi\Http\Requests\CompanyUpdateRequest;

class CompanyController extends Controller
{

    public function __construct(CompanyRepository $company)
    {
        $this->company = $company;
    }

    /**
     * Display a listing of the resource.
     * @return Renderable
     */
    public function index()
    {
        $companies = $this->company->all();
        return response()->json([
            'success' => TRUE,
            'data' => $companies
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     * @param Request $request
     * @return Renderable
     */
    public function store(CompanyStoreRequest $request)
    {
        try {
            $extension = $request->file('logo')->getClientOriginalExtension();
            $imgName = time(). '-' .\Str::slug($request->name) . '-' . 'logo.'.$extension;
            $path = Storage::putFileAs('company', $request->file('logo'), $imgName);

            $collection = [
                'name' => $request->name,
                'email' => $request->email,
                'logo' => $imgName,
                'website' => $request->website
            ];

            $this->company->store($collection);

            return response()->json([
                'success'=> TRUE, 
                'message'=> 'The company has been created successfully.', 
                'data'=> $collection
            ]);
        } catch (\Exception $e) {
            return response()->json([
                'success'=> FALSE, 
                'message'=> $e->getMessage()
            ], 500);
        } 

    }

    /**
     * Show the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function show($id)
    {
        try {
            $company = $this->company->find($id);
            if ($company) {
                return response()->json([
                    'success'=> TRUE, 
                    'data'=> $company
                ]);
            } else {
                return response()->json([
                    'success'=> FALSE, 
                    'message'=> 'Company ID not found'
                ], 404);
            }
        } catch (\Exception $e) {
            return response()->json([
                'success'=> FALSE, 
                'message'=> $e->getMessage()
            ], 500);
        } 
    }


    public function update(CompanyUpdateRequest $request, $id)
    {
        try {
            if ($request->hasFile('logo')) {
                $extension = $request->file('logo')->getClientOriginalExtension();
                $imgName = time(). '-' .\Str::slug($request->name) . '-' . 'logo.'.$extension;
                $path = Storage::putFileAs('company', $request->file('logo'), $imgName);
    
                $collection = [
                    'name' => $request->name,
                    'email' => $request->email,
                    'website' => $request->website,
                    'logo' => $imgName
                ];            
            } else {
                $collection = [
                    'name' => $request->name,
                    'email' => $request->email,
                    'website' => $request->website
                ];
            }
    
            $this->company->update($id, $collection);
    
            return response([
                'success'=> TRUE, 
                'message'=> 'The company has been updated successfully.', 
                'data'=> $collection
            ]);
        } catch (\Exception $e) {
            return response()->json([
                'success'=> FALSE, 
                'message'=> $e->getMessage()
            ], 500);
        }
        
    }

    /**
     * Remove the specified resource from storage.
     * @param int $id
     * @return Renderable
     */
    public function destroy($id)
    {
        try {
            $company = $this->company->find($id);
            if ($company) {
                $this->company->destroy($id);
                return response([
                    'success'=> TRUE, 
                    'message'=> 'The company has been deleted successfully.', 
                ]);
            } else {
                return response([
                    'success'=> FALSE, 
                    'message'=> 'Company not found.', 
                ], 404);
            }    
        } catch (\Exception $e) {
            return response()->json([
                'success'=> FALSE, 
                'message'=> $e->getMessage()
            ], 500);
        }
        
    }
}

Modules/Transisi/Http/Controllers/CompanyController.php
<?php

namespace Modules\Transisi\Http\Controllers;

use PDF;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\Storage;
use Modules\Transisi\Entities\Employee;
use Illuminate\Contracts\Support\Renderable;
use Modules\Transisi\Repositories\CompanyRepository;
use Modules\Transisi\Http\Requests\CompanyStoreRequest;
use Modules\Transisi\Http\Requests\CompanyUpdateRequest;

class CompanyController extends Controller
{

    public function __construct(CompanyRepository $company)
    {
        $this->company = $company;
    }

    /**
     * Display a listing of the resource.
     * @return Renderable
     */
    public function index()
    {
        $companies = $this->company->all();
        return view('transisi::companies.index', compact('companies'));
    }

    /**
     * Show the form for creating a new resource.
     * @return Renderable
     */
    public function create()
    {
        return view('transisi::companies.create');
    }

    /**
     * Store a newly created resource in storage.
     * @param Request $request
     * @return Renderable
     */
    public function store(CompanyStoreRequest $request)
    {
        $extension = $request->file('logo')->getClientOriginalExtension();
        $imgName = time(). '-' .\Str::slug($request->name) . '-' . 'logo.'.$extension;
        $path = Storage::putFileAs('company', $request->file('logo'), $imgName);

        $collection = [
            'name' => $request->name,
            'email' => $request->email,
            'logo' => $imgName,
            'website' => $request->website
        ];

        $this->company->store($collection);

        return redirect()->route('companies.index')->with('success', 'Input Berhasil');
    }

    /**
     * Show the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function show($id)
    {
        $company = $this->company->find($id);
        $employees = $this->company->employees($id);
        return view('transisi::companies.show', compact('company', 'employees'));
    }

    /**
     * Show the form for editing the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function edit($id)
    {
        $company = $this->company->find($id);

        return view('transisi::companies.edit', compact('company'));
    }

    /**
     * Update the specified resource in storage.
     * @param Request $request
     * @param int $id
     * @return Renderable
     */
    public function update(CompanyUpdateRequest $request, $id)
    {
        if ($request->hasFile('logo')) {
            $extension = $request->file('logo')->getClientOriginalExtension();
            $imgName = time(). '-' .\Str::slug($request->name) . '-' . 'logo.'.$extension;
            $path = Storage::putFileAs('company', $request->file('logo'), $imgName);

            $collection = [
                'name' => $request->name,
                'email' => $request->email,
                'website' => $request->website,
                'logo' => $imgName
            ];            
        } else {
            $collection = [
                'name' => $request->name,
                'email' => $request->email,
                'website' => $request->website
            ];
        }

        $this->company->update($id, $collection);


        return redirect()->route('companies.index')->with('success', 'Update Berhasil');
    }

    /**
     * Remove the specified resource from storage.
     * @param int $id
     * @return Renderable
     */
    public function destroy($id)
    {
        $company = $this->company->find($id);
        if ($company) {
            $this->company->destroy($id);
            return redirect()->route('companies.index')->with('success', 'Hapus Berhasil');
        } else {
            return redirect()->route('companies.index')->with('error', 'Error');
        }
    }

    // for ajax
    public function getCompanies(Request $request)
    {
        $keyword = $request->search;
        if($keyword == ''){
            $companies = $this->company->all();
        } else {
            $companies = $this->company->searchCompanies($keyword);
        }

        foreach($companies as $company){
            $response[] = array(
                    "id"=>$company->id,
                    "text"=>$company->name,
            );
            }
    
            return response()->json($response);
    }

    public function exportPdf($id)
    {
        $company = $this->company->find($id);

        $data['employees'] = $this->company->employeesForExport($id);       
        $data['companyName'] = $company->name;
        
        $pdf = PDF::loadView('transisi::exports.employees', $data);
        
        return $pdf->download('employee.pdf');
    }

}

Modules/Transisi/Resources/views/companies/create.blade.php
@extends('transisi::layouts.master')

@section('content')

<div class="container">
  <div class="card">
    <div class="card-header">
      Tambah Company
    </div>
    <div class="card-body">

      <form action="{{ route('companies.store') }}" method="post" enctype="multipart/form-data">@csrf
        <div class="form-group">
          <label for="name">Nama</label>
          <input type="text" class="form-control" name="name" value="{{ old('name') }}">
          @error('name')
          <span class="text-danger">
          {{ $errors->first('name') }}
          </span>
          @enderror
        </div>

        <div class="form-group">
          <label for="email">Email</label>
          <input type="email" class="form-control" name="email" value="{{ old('email') }}">
          @error('email')
          <span class="text-danger">
          {{ $errors->first('email') }}
          </span>
          @enderror
        </div>

        <div class="form-group">
          <label for="logo">Logo</label>
          <input type="file" class="form-control-file" name="logo">
          <span class="text-danger d-block">*minimum 100x100 px, png, ukuran maks 2 MB</span>
          @error('logo')
          <span class="text-danger">
          {{ $errors->first('logo') }}
          </span>
          @enderror
        </div>

        <div class="form-group">
          <label for="name">Website</label>
          <input type="text" class="form-control" name="website" value="{{ old('website') }}">
          @error('website')
          <span class="text-danger">
          {{ $errors->first('website') }}
          </span>
          @enderror
        </div>

        <button type="submit" class="btn btn-primary">Submit</button>
      </form>
    </div>
  </div>
</div>
@endsection

Modules/Transisi/Resources/views/companies/edit.blade.php
@extends('transisi::layouts.master')
@section('content')


<div class="container">
  <div class="card">
    <div class="card-header">
      Tambah Company
    </div>
    <div class="card-body">

      <form action="{{ route('companies.update', $company) }}" method="post" enctype="multipart/form-data">@csrf @method('put')
        <div class="form-group">
          <label for="name">Nama</label>
          <input type="text" class="form-control" name="name" value="{{ $company->name }}">
          @error('name')
          <span class="text-danger">
          {{ $errors->first('name') }}
          </span>
          @enderror
        </div>

        <div class="form-group">
          <label for="email">Email</label>
          <input type="email" class="form-control" name="email" value="{{ $company->email }}">
          @error('email')
          <span class="text-danger">
          {{ $errors->first('email') }}
          </span>
          @enderror
        </div>

        <div class="form-group">
          <label for="logo">Logo</label>
          <input type="file" class="form-control-file" name="logo">
          <span class="text-danger">minimum 100x100 px, png, ukuran maks 2 MB</span>
          @error('logo')
          <span class="text-danger">
          {{ $errors->first('logo') }}
          </span>
          @enderror
        </div>

        <div class="form-group">
          <label for="name">Website</label>
          <input type="text" class="form-control" name="website" value="{{ $company->website }}">
          @error('website')
          <span class="text-danger">
          {{ $errors->first('website') }}
          </span>
          @enderror
        </div>

        <button type="submit" class="btn btn-primary">Submit</button>
      </form>
    </div>
  </div>
</div>
@endsection

Modules/Transisi/Resources/views/companies/index.blade.php
@extends('transisi::layouts.master')

@section('content')
<div class="container">
@if(Session::has('success'))
  <div class="alert alert-success">
      {{ Session::get('success') }}
      @php
          Session::forget('success');
      @endphp
  </div>
@endif
  <div class="card">
    <div class="card-header">
      Data Company
    </div>
    <div class="card-body">
      <div class="d-flex justify-content-end">
        <a href="{{ route('companies.create') }}" class="btn btn-primary btn-sm my-2 pull-right">Tambah Company</a>
      </div>
      <div class="table-responsive">
        <table class="table table-hover">
          <thead>
            <tr>
              <th scope="col">No</th>
              <th scope="col">Nama</th>
              <th scope="col">Email</th>
              <th scope="col">Logo</th>
              <th scope="col">Website</th>
              <th scope="col">Aksi</th>
            </tr>
          </thead>
          <tbody>
            @foreach($companies as $company)
            <tr>
              <th>{{ $loop->iteration }}</th>
              <td>{{ $company->name }}</td>
              <td>{{ $company->email }}</td>
              <td>
                <a href="{{ asset('company/'.$company->logo) }}" target="_blank" title="Lihat Foto"><img src="{{ asset('company/'.$company->logo) }}" alt="" style="height: 30px"></a>
              </td>
              <td>{{ $company->website }}</td>
              <td>
                <a href="{{ route('companies.edit', $company->id) }}" class="btn btn-sm btn-warning">Edit</a>
                <a href="{{ route('companies.show', $company->id) }}" class="btn btn-sm btn-warning">Detail</a>
                <form action="{{ route('companies.destroy', $company) }}" method="post" style="display:inline">
                @csrf @method('DELETE')
                  <button class="btn btn-danger btn-sm" type="submit">Hapus</button>
                </form>
              </td>
            </tr>
            @endforeach
          </tbody>
        </table>
      </div>
      {{ $companies->links() }}
    </div>
  </div>
</div>
@endsection

Modules/Transisi/Resources/views/companies/show.blade.php
@extends('transisi::layouts.master')

@section('content')
@php
  use Modules\Transisi\Constants\Status;
@endphp

<div class="container">
@if(Session::has('success'))
  <div class="alert alert-success">
      {{ Session::get('success') }}
      @php
          Session::forget('success');
      @endphp
  </div>
@endif
  <div class="card">
    <div class="card-header">
      Data Company
    </div>
    <div class="card-body">
      <div class="row">
        <div class="col-12">
          <a href="{{ asset('company/'.$company->logo) }}" target="_blank" title="Lihat Foto"><img src="{{ asset('company/'.$company->logo) }}" alt="" style="height: 64px"></a>
          <div>Name: {{$company->name}}</div>
          <div>Email: {{$company->email}}</div>
          <div>Website: {{$company->website}}</div>
        </div>
      </div>

      <hr>
      <div class="row">
        <div class="col-12">
          <h5>Employees</h5>
          <div class="d-flex justify-content-end">
            <a href="{{ route('companies.export.pdf', $company->id) }}" class="btn btn-primary btn-sm my-2 pull-right">Export PDF</a>
          </div>
          <div class="table-responsive">
            <table class="table table-hover">
              <thead>
                <tr>
                  <th scope="col">No</th>
                  <th scope="col">Nama</th>
                  <th scope="col">Email</th>
                  <th scope="col">Status</th>
                </tr>
              </thead>
              <tbody>
                @foreach($employees as $employee)
                <tr>
                  <td>{{$loop->iteration}}</td>
                  <td>{{$employee->name}}</td>
                  <td>{{$employee->email}}</td>
                  <td>{{Status::label($employee->status)}}</td>
                </tr>
                @endforeach
              
              </tbody>
            </table>
          </div>
          {{ $employees->links() }}
        </div>
      </div>
    
    </div>
  </div>
</div>
@endsection